diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/mcmc.c mrbayes-3.1.2.new/mcmc.c
--- mrbayes-3.1.2.old/mcmc.c	Wed Apr 18 12:19:46 EDT 2007
+++ mrbayes-3.1.2.new/mcmc.c	Thu Nov 22 12:52:14 EST 2007
@@ -33829,20 +35535,39 @@
 				MrBayesPrint ("%s   Acceptance rates for the moves in chain %d of run %d (heated):\n", spacer, j%chainParams.numChains+1, j/chainParams.numChains+1);
 			}
 
-		if (j % chainParams.numChains == 0 || chainParams.allChains == YES)
-			{
+		if (j % chainParams.numChains == 0 || chainParams.allChains == YES) {
 			MrBayesPrint ("%s      With prob.  Chain accepted changes to\n", spacer);
 
-			for (i=0; i<numMoves; i++)
-				{
+		  for (i=0; i<numMoves; i++) {
 				mv = &moves[i];
-				if (mv->nTried[0] == 0)
+		    if (mv->nTried[j] == 0)
 					MrBayesPrint ("%s      not tried   param. %d %s\n", spacer, mv->parm->index+1, mv->name);
+		    else {
+		      MrBayesPrint ("%s       %6.2f %%   param. %d %s\n", spacer,
+				    100.0*(MrBFlt)(mv->nAccepted[j])/(MrBFlt)(mv->nTried[j]), mv->parm->index+1,
+				    mv->name);
+		      if ((chainParams.useAdapt == YES) && (mv->doAdaptParam == YES)) {
+			if (mv->nTriedAfterAdapt > 0)
+			  MrBayesPrint("%s       %6.2f %%   param. %d %s after adapt\n", spacer,
+				       100.0*(MrBFlt)(mv->nAcceptedAfterAdapt)/(MrBFlt)(mv->nTriedAfterAdapt),
+				       mv->parm->index+1, mv->name);
 				else
-					MrBayesPrint ("%s       %6.2f %%   param. %d %s\n", spacer, 100.0*(MrBFlt)(mv->nAccepted[j])/(MrBFlt)(mv->nTried[j]), mv->parm->index+1, mv->name);
+			  MrBayesPrint("%s       not tried  param. %d %s after adapt\n", spacer,
+				       mv->parm->index+1, mv->name);
+			k = mv->whichAdaptParam;
+			MrBayesPrint("%s     Adapt:             %6.6f to       %6.6f\n",spacer,
+				     mv->oldTuningParam,mv->tuningParam[k]);
+			MrBayesPrint("%s     Adapt tried:       %6.6f to       %6.6f\n",spacer,
+				     mv->minParamTried, mv->maxParamTried);
+			MrBayesPrint("%s     Adapt accepted:    %6.6f to       %6.6f\n",spacer,
+				     mv->minParamAccepted, mv->maxParamAccepted);
+			MrBayesPrint("%s     Adapt refused:     %6.6f to       %6.6f\n",spacer,
+				     mv->minParamRefused, mv->maxParamRefused);
 				}
 			}
 		}
+		}
+	}
 
 	/* output information on the success of the chain state swap proposals */
 	if (PrintSwapInfo () == ERROR)
@@ -33899,16 +35624,52 @@
 int SaveSprintf(char **target, int *targetLen, char *fmt, ...) {
   va_list    argp;
   int        len,retval;
+#if !defined(VISUAL)
+  char  *tempStr;
+#endif
 
   va_start(argp, fmt);
 #ifdef VISUAL
   len = _vsnprintf(NULL, 0, fmt, argp);
 #else
+# ifdef _SGI_SOURCE
+   len = _xpg5_vsnprintf(NULL, 0, fmt, argp);
+   if (len < 0) {
+     va_end(argp);
+     va_start(argp, fmt);
+     tempStr = (char *) SafeMalloc((size_t) (*targetLen * sizeof(char)));
+     if (tempStr) {
+      len = _xpg5_vsnprintf(tempStr, *targetLen, fmt, argp);
+      free(tempStr);
+     }
+   }
+# else
   len = vsnprintf(NULL, 0, fmt, argp);
+   if (len < 0) {
+     va_end(argp);
+     va_start(argp, fmt);
+     tempStr = (char *) SafeMalloc((size_t) (*targetLen * sizeof(char)));
+     if (tempStr) {
+      len = vsnprintf(tempStr, *targetLen, fmt, argp);
+      free(tempStr);
+     }
+   }
+# endif
+#endif
+
+  if (len < 0) {
+    fprintf(stderr, "Negative length for printing to /%s/ in SaveSprintf\n",*target);
+#ifdef BUFSIZ
+    len = *targetLen + BUFSIZ;
+#else
+    len = *targetLen + 4096;
 #endif
+  }
 
   va_end(argp);
 
+  len++; /* len from vsnprintf does not include trailing null - Allen */
+
   if(len>*targetLen) 
         {
 /* 	  fprintf(stderr, "* increasing buffer from %d to %d bytes\n", *targetLen, len+TARGETLENDELTA); */
@@ -33917,7 +35678,11 @@
         }
 
   va_start(argp,fmt);
+#ifdef VISUAL
   retval=vsprintf(*target, fmt, argp);
+#else
+  retval=vsnprintf(*target, *targetLen, fmt, argp);
+#endif
   va_end(argp);
 
 /*   fprintf(stderr, "* savesprintf /%s/\n",*target); */
@@ -35504,11 +37270,19 @@
 					}
 
 			/* find the parameter x prior type */
+			if (mp->dataType == PROTEIN) { /* Allen */
+				if ((!strcmp(mp->aaModelPr, "Fixed")) &&
+				    (!strcmp(mp->aaModel, "Gtr")) &&
+				    (!strcmp(mp->aaRevMatPr,"Dirichlet")))
+					p->paramId = REVMAT_DIR;
+				else
+					p->paramId = REVMAT_FIX;
+			} else {
 			if (!strcmp(mp->revMatPr,"Dirichlet"))
 				p->paramId = REVMAT_DIR;
 			else
 				p->paramId = REVMAT_FIX;
-
+			}
 			if (p->paramId != REVMAT_FIX)
 				p->printParam = YES;
 			if (FillRelPartsString (p, partString) == YES)
@@ -35548,7 +37322,6 @@
 								{
 								SaveSprintf(&tempStr, &tempStrSize, "\tr(%c<->%c)", StateCode_AA(n1), StateCode_AA(n2));
 								strcat (p->paramName, tempStr);
-								strcat (p->paramName, partString);
 								}
 							}
 						}
@@ -36157,7 +37930,12 @@
 			/* find the parameter x prior type */
 			if (!strcmp(mp->covSwitchPr,"Uniform"))
 				p->paramId = SWITCH_UNI;
-			else if (!strcmp(mp->covSwitchPr,"Exponential"))
+			else if (!strcmp(mp->covSwitchPr,"PinvarUniform")) { /* - Allen */
+			  if (mp->covswitchMaxPinvar < 1)
+			    p->paramId = SWITCH_PINVUNI;
+			  else
+			    p->paramId = SWITCH_UNI;
+			} else if (!strcmp(mp->covSwitchPr,"Exponential"))
 				p->paramId = SWITCH_EXP;
 			else
 				p->paramId = SWITCH_FIX;
@@ -37036,11 +38814,11 @@
 		/* check if we should calculate ancestral states */
 		if (!strcmp(mp->inferAncStates,"Yes"))
 			{
-			if (mp->dataType == PROTEIN && !strcmp(mp->covarionModel, "No"))
+			if (mp->dataType == PROTEIN) /* am implementing covarion anc states - Allen */
 				m->printAncStates = YES;
 			else if (mp->dataType == DNA || mp->dataType == RNA)
 				{
-				if (!strcmp(mp->nucModel,"4by4") && !strcmp(mp->covarionModel, "No"))
+				if (!strcmp(mp->nucModel,"4by4"))
 					m->printAncStates = YES;
 				}
 			else if (mp->dataType == STANDARD || mp->dataType == RESTRICTION)
@@ -37087,7 +38865,7 @@
 
 {
 	
-	int			i, j, j1, k, n;
+	int			i, j, j1, k, n, has_covarion;
 	MrBFlt		sum;
 
 	Param		*p;
@@ -37109,9 +38887,22 @@
 		for (i=0; i<NUM_MOVE_TYPES; i++)
 			for (j=0; j<moveTypes[i].nApplicable; j++)
 				if (moveTypes[i].applicableTo[j] == p->paramId)
-					if (p->relProposalProb * moveTypes[i].relProposalProb > 0.00001)
+			    if (p->relProposalProb * moveTypes[i].relProposalProb > 0.00001) {
+			      if (moveTypes[i].covarion_wanted != 0) {
+				has_covarion = -1;
+				/* gamma has diff acceptances with, w/out covarion - Allen */
+				for (j1=0; j1<p->nRelParts; j1++) {
+				  if (!strcmp(modelParams[p->relParts[j1]].covarionModel, "Yes")) {
+				    has_covarion = 1;
+				    break;
+				  }
+				}
+				if (has_covarion != moveTypes[i].covarion_wanted)
+				  continue;
+			      }
 						numMoves++;
 		}
+		}
 
 	/* then allocate space for moves */
 	if (memAllocs[ALLOC_MOVES] == YES)
@@ -37153,6 +38944,18 @@
 					{
 					if (p->relProposalProb * moveTypes[i].relProposalProb < 0.00001)
 						continue;
+					if (moveTypes[i].covarion_wanted != 0) {
+					  has_covarion = -1;
+					  /* gamma has diff acceptances with, w/out covarion - Allen */
+					  for (j1=0; j1<p->nRelParts; j1++) {
+					    if (!strcmp(modelParams[p->relParts[j1]].covarionModel, "Yes")) {
+					      has_covarion = 1;
+					      break;
+					    }
+					  }
+					  if (has_covarion != moveTypes[i].covarion_wanted)
+					    continue;
+					}
 					moves[n].name = moveTypes[i].name;
 					moves[n].shortName = moveTypes[i].shortName;
 					moves[n].relProposalProb = p->relProposalProb * moveTypes[i].relProposalProb;
@@ -37160,6 +38963,45 @@
 					moves[n].cumProposalProb = sum;
 					moves[n].parm = p;
 					moves[n].moveFxn = moveTypes[i].moveFxn;
+					moves[n].doAdaptParam = moveTypes[i].doAdaptParam;
+					moves[n].whichAdaptParam = moveTypes[i].whichAdaptParam;
+					if ((moves[n].doAdaptParam == YES) &&
+					    (moveTypes[i].minimum[moves[n].whichAdaptParam] < LIKE_EPSILON)) {
+					  MrBayesPrint ("%s   WARNING: %s cannot be adaptive due to too-low minimum %lf\n",
+							spacer, moves[n].name,
+							moveTypes[i].minimum[moves[n].whichAdaptParam]);
+					  moves[n].doAdaptParam = NO;
+					}
+					moves[n].adaptMultiplier = moveTypes[i].adaptMultiplier;
+					if (moves[n].doAdaptParam == YES) {
+					  moves[n].oldTuningParam = moveTypes[i].tuningParam[moves[n].whichAdaptParam];
+					  moves[n].minParamTried = moves[n].oldTuningParam;
+					  moves[n].maxParamTried = moves[n].oldTuningParam;
+					  moves[n].minAdapt = moveTypes[i].minimum[moves[n].whichAdaptParam];
+					  if (p->paramId == SHAPE_UNI)
+					    moves[n].maxAdapt =
+					      MinimumValue(moveTypes[i].maximum[moves[n].whichAdaptParam],
+							   (log(modelParams[p->relParts[0]].shapeUni[1]/
+								modelParams[p->relParts[0]].shapeUni[0])*2.0));
+					  else if ((p->paramId == SWITCH_UNI) || (p->paramId == SWITCH_PINVUNI))
+					    moves[n].maxAdapt =
+					      MinimumValue(moveTypes[i].maximum[moves[n].whichAdaptParam],
+							   ((modelParams[p->relParts[0]].covswitchUni[1] -
+							     modelParams[p->relParts[0]].covswitchUni[0])*2.0));
+					  else
+					    moves[n].maxAdapt = moveTypes[i].maximum[moves[n].whichAdaptParam];
+					  moves[n].minParamRefused = moves[n].maxAdapt;
+					  moves[n].maxParamRefused = moves[n].minAdapt;
+					  moves[n].minParamAccepted = moves[n].maxAdapt;
+					  moves[n].maxParamAccepted = moves[n].minAdapt;
+					  if (moves[n].adaptMultiplier == YES) { /* precalculate */
+					    moves[n].minAdaptMult = exp(moves[n].minAdapt/2.0);
+					    moves[n].maxAdaptMult = exp(moves[n].maxAdapt/2.0);
+					  }
+					}
+					moves[n].minAdaptCFactor = moveTypes[i].minAdaptCFactor;
+					moves[n].nTriedAfterAdapt = 0;
+					moves[n].nAcceptedAfterAdapt = 0;
 					for (j1=0; j1<chainParams.numRuns; j1++)
 						moves[n].nAccepted[j1] = moves[n].nTried[j1] = 0;
 					moves[n].tuningParam[0] = moveTypes[i].tuningParam[0];
@@ -38316,6 +40158,12 @@
 		mt->name = mt->shortName = mt->nameTuning[0] = mt->nameTuning[1] = "";
 		mt->relProposalProb = 0.0;
 		mt->parsimonyBased = NO;
+		mt->doAdaptParam = NO;
+		mt->whichAdaptParam = 0;
+		mt->adaptMultiplier = NO;
+		/* if had acceptance rate of 1.0, would mult by 1/0.7 */
+		mt->minAdaptCFactor = (1.0/0.7)-1.0;
+		mt->covarion_wanted = 0;
 		}
 
 	/* All moves are in alphabetic order of move function name. This list should match
@@ -38343,9 +40191,9 @@
 	mt->applicableTo[0] = CORREL_UNI;
 	mt->nApplicable = 1;
 	mt->moveFxn = &Move_Adgamma;
-	mt->relProposalProb = 1.0;
+	mt->relProposalProb = 3.0; /* changed from 1.0 - Allen */
 	mt->numTuningParams = 1;
-	mt->tuningParam[0] = 0.5;  /* window size */
+	mt->tuningParam[0] = 0.25;  /* window size - changed to 0.25 due to usage of 0<->1 range - Allen */
 	mt->minimum[0] = 0.001;
 	mt->maximum[0] = 1.999;
 	mt->parsimonyBased = NO;
@@ -38400,12 +40248,20 @@
 	mt->applicableTo[1] = BRLENS_EXP;
 	mt->nApplicable = 2;
 	mt->moveFxn = &Move_BrLen;
+#ifdef NOTOPOLOGY /* - Allen */
+	mt->relProposalProb = 10.0;
+#else
 	mt->relProposalProb = 0.0;
+#endif
 	mt->numTuningParams = 1;
-	mt->tuningParam[0] = 2.0 * log (2.0);  /* lambda */
-	mt->minimum[0] = 0.00001;
-	mt->maximum[0] = 10000000.0;
+	mt->tuningParam[0] = 2.0 * log (20.0);  /* lambda; was log(2.0) - Allen */
+	mt->minimum[0] = 2.0 * log((BRLEN_EPSILON+BRLENS_MIN)/BRLENS_MIN);
+	mt->maximum[0] = log(BRLENS_MAX/BRLENS_MIN)*2.0; /* original would cause problems with exp - Allen */
 	mt->parsimonyBased = NO;
+	mt->doAdaptParam = YES;
+	mt->whichAdaptParam = 0;
+	mt->adaptMultiplier = YES;
+	/* leaving minAdaptCFactor at default for now */
 	mt->level = STANDARD_USER;
 
 	/* Move_Extinction */
@@ -38534,14 +40390,18 @@
 	mt->applicableTo[1] = TOPOLOGY_NCL_CONSTRAINED_HOMO;
 	mt->nApplicable = 2;
 	mt->moveFxn = &Move_ExtTBR;
-	mt->relProposalProb = 15.0;
+#ifdef NOTOPOLOGY /* -Allen */
+	mt->relProposalProb = 0.0;
+#else
+	mt->relProposalProb = 22.0; /* changed from 15.0 - Allen */
+#endif
 	mt->numTuningParams = 2;
-	mt->tuningParam[0] = 0.8;  /* extension probability */
-	mt->tuningParam[1] = 2.0 * log (1.6);  /* lambda */
+	mt->tuningParam[0] = 0.54;  /* extension probability */ /* changed from 0.8 - Allen */
+	mt->tuningParam[1] = 2.0 * log (1.048);  /* lambda */ /* changed from 2.0 * log(1.6) - Allen */
 	mt->minimum[0] = 0.00001;
 	mt->maximum[0] = 0.99;
 	mt->minimum[1] = 0.00001;
-	mt->maximum[1] = 10000000.0;
+	mt->maximum[1] = 200.0; /* default changed due to potential problems with exp - Allen */
 	mt->parsimonyBased = NO;
 	mt->level = STANDARD_USER;
 
@@ -38631,7 +40491,7 @@
 
 	/* Move_GammaShape_M */
 	mt = &moveTypes[i++];
-	mt->name = "(gamma shape) with multiplier";
+	mt->name = "(gamma shape) with multiplier (non-covarion)";
 	mt->nameTuning[0] = "multiplier tuning parameter (lambda)";
 	mt->shortName = "mult";
 	mt->applicableTo[0] = SHAPE_UNI;
@@ -38640,10 +40500,37 @@
 	mt->moveFxn = &Move_GammaShape_M;
 	mt->relProposalProb = 1.0;
 	mt->numTuningParams = 1;
-	mt->tuningParam[0] = 2.0 * log (1.5);  /* lambda */
+	mt->tuningParam[0] = 2.0 * log(1.5); /* lambda for non-covarion - Allen */
+	mt->minimum[0] = 2.0 * log(0.65/(0.65-MIN_SHAPE_PARAM)); /* 0.65 is equiv to Grishin distance - Allen */
+	/* orig 10000000.0 as max caused problems with exp - Allen */
+	mt->maximum[0] = log(MAX_SHAPE_PARAM/MIN_SHAPE_PARAM)*2.0;
+	mt->parsimonyBased = NO;
+	mt->doAdaptParam = YES;
+	mt->whichAdaptParam = 0;
+	mt->adaptMultiplier = YES;
+	mt->covarion_wanted = -1;
+	/* leaving minAdaptCFactor as per default */
+	mt->level = STANDARD_USER;
+
+	mt = &moveTypes[i++];
+	mt->name = "(gamma shape) with multiplier (covarion)";
+	mt->nameTuning[0] = "multiplier tuning parameter (lambda)";
+	mt->shortName = "mult_with_covarion";
+	mt->applicableTo[0] = SHAPE_UNI;
+	mt->applicableTo[1] = SHAPE_EXP;
+	mt->nApplicable = 2;
+	mt->moveFxn = &Move_GammaShape_M; /* same function as above! - Allen */
+	mt->relProposalProb = 1.5; /* was 1.0 - Allen */
+	mt->numTuningParams = 1;
+	mt->tuningParam[0] = 2.0 * log(1.00003); /* lambda for covarion - Allen */
 	mt->minimum[0] = 0.00001;
-	mt->maximum[0] = 10000000.0;
+	mt->maximum[0] = log(MAX_SHAPE_PARAM/MIN_SHAPE_PARAM)*2.0; /* see above */
 	mt->parsimonyBased = NO;
+	mt->doAdaptParam = YES;
+	mt->whichAdaptParam = 0;
+	mt->adaptMultiplier = YES;
+	mt->covarion_wanted = 1;
+	/* leaving minAdaptCFactor as per default */
 	mt->level = STANDARD_USER;
 
 	/* Move_Growth */
@@ -38673,11 +40560,15 @@
 	mt->applicableTo[1] = TOPOLOGY_NCL_CONSTRAINED_HOMO;
 	mt->nApplicable = 2;
 	mt->moveFxn = &Move_Local;
-	mt->relProposalProb = 5.0;
+#ifdef NOTOPOLOGY /* - Allen */
+	mt->relProposalProb = 0.0;	
+#else
+	mt->relProposalProb = 14.0; /* changed from 5.0 - Allen */
+#endif
 	mt->numTuningParams = 1;
-	mt->tuningParam[0] = 2.0 * log (1.1);  /* lambda */
+	mt->tuningParam[0] = 2.0 * log (1.00105);  /* lambda */ /* changed from log(1.1) - Allen */
 	mt->minimum[0] = 0.00001;
-	mt->maximum[0] = 10000000.0;
+	mt->maximum[0] = 200.0; /* changed from 10000000.0 due to problems with exp - Allen */
 	mt->parsimonyBased = NO;
 	mt->level = STANDARD_USER;
 
@@ -38738,10 +40629,43 @@
 	mt->moveFxn = &Move_NodeSlider;
 	mt->relProposalProb = 0.0;
 	mt->numTuningParams = 1;
-	mt->tuningParam[0] = 2.0 * log (1.1);  /* lambda */
-	mt->minimum[0] = 0.00001;
-	mt->maximum[0] = 10000000.0;
+	mt->tuningParam[0] = 2.0 * log(1.02);  /* lambda; was log(1.1) - Allen */
+	mt->minimum[0] = 2.0 * log((BRLEN_EPSILON+BRLENS_MIN)/BRLENS_MIN);
+	mt->maximum[0] = log(BRLENS_MAX/BRLENS_MIN)*2.0; /* see Move_BrLen */
+	mt->parsimonyBased = NO;
+	mt->doAdaptParam = NO; /* turning off b/c is too insensitive to tuning param; use SimAnneal instead */
+	mt->whichAdaptParam = 0;
+	mt->adaptMultiplier = YES;
+	mt->minAdaptCFactor = 2; /* guess! move is relatively insensitive to tuning parameter... - Allen */
+	mt->level = STANDARD_USER;
+
+	/* Move_NodeSlider2 */
+	mt = &moveTypes[i++];
+	mt->name = "(branch lengths) with nodeslider2";
+	mt->nameTuning[0] = "multiplier tuning parameter (lambda)";
+	mt->nameTuning[1] = "sliding window size for proportion";
+	mt->shortName = "nslider2";
+	mt->applicableTo[0] = BRLENS_UNI;
+	mt->applicableTo[1] = BRLENS_EXP;
+	mt->nApplicable = 2;
+	mt->moveFxn = &Move_NodeSlider2;
+#ifdef NOTOPOLOGY /* - Allen */
+	mt->relProposalProb = 27.0;
+#else
+	mt->relProposalProb = 0.0;
+#endif
+	mt->numTuningParams = 2;
+	mt->tuningParam[0] = 2.0 * log(1.011);  /* lambda; was log(1.1) - Allen */
+	mt->minimum[0] = 2.0 * log((BRLEN_EPSILON+BRLENS_MIN)/BRLENS_MIN);
+	mt->maximum[0] = log(BRLENS_MAX/BRLENS_MIN)*2.0; /* see Move_BrLen */
+	mt->tuningParam[1] = 0.05;
+	mt->minimum[1] = 0.002;
+	mt->maximum[1] = 0.999;
 	mt->parsimonyBased = NO;
+	mt->doAdaptParam = YES;
+	mt->whichAdaptParam = 1;
+	mt->adaptMultiplier = NO;
+	/* leaving minAdaptCFactor at default */
 	mt->level = STANDARD_USER;
 
 	/* Move_NodeSliderClock */
@@ -38976,12 +40900,15 @@
 	mt->applicableTo[0] = PINVAR_UNI;
 	mt->nApplicable = 1;
 	mt->moveFxn = &Move_Pinvar;
-	mt->relProposalProb = 1.0;
+	mt->relProposalProb = 0.5; /* was 1.0 - Allen */
 	mt->numTuningParams = 1;
 	mt->tuningParam[0] = 0.1;  /* window size */
-	mt->minimum[0] = 0.001;
+	mt->minimum[0] = 0.002; /* is mult by max of 0.5 - Allen */
 	mt->maximum[0] = 0.999;
 	mt->parsimonyBased = NO;
+	mt->doAdaptParam = YES; /* - Allen */
+	mt->whichAdaptParam = 0;
+	/* leaving minAdaptCFactor at default */
 	mt->level = STANDARD_USER;
 
 	/* Move_RanSPR1 */
@@ -39076,9 +41003,13 @@
 	mt->applicableTo[0] = RATEMULT_DIR;
 	mt->nApplicable = 1;
 	mt->moveFxn = &Move_RateMult_Dir;
-	mt->relProposalProb = 1.0;
+#ifdef NOTOPOLOGY
+	mt->relProposalProb = 5.0;
+#else
+	mt->relProposalProb = 10.0; /* was 1.0; should really be proportional to num of rate partitions... XXX - Allen */
+#endif
 	mt->numTuningParams = 1;
-	mt->tuningParam[0] = 500.0; /* alphaPi */
+	mt->tuningParam[0] = 5000.0; /* alphaPi; was 500.0 - Allen */
 	mt->minimum[0] = 0.00000001;
 	mt->maximum[0] = 10000000.0;
 	mt->parsimonyBased = NO;
@@ -39092,7 +41023,7 @@
 	mt->applicableTo[0] = REVMAT_DIR;
 	mt->nApplicable = 1;
 	mt->moveFxn = &Move_Revmat_Dir;
-	mt->relProposalProb = 1.0;
+	mt->relProposalProb = 3.0; /* was 1.0 - Allen */
 	mt->numTuningParams = 1;
 	mt->tuningParam[0] = 500.0;  /* alphaPi */
 	mt->minimum[0] = 0.0001;
@@ -39164,7 +41095,7 @@
 	mt->applicableTo[0] = PI_DIR;
 	mt->nApplicable = 1;
 	mt->moveFxn = &Move_Statefreqs;
-	mt->relProposalProb = 1.0;
+	mt->relProposalProb = 0.5; /* changed from 1.0 - Allen */
 	mt->numTuningParams = 1;
 	mt->tuningParam[0] = 300.0; /* so-called "alphaPi" */
 	mt->minimum[0] = 0.001;
@@ -39196,15 +41127,19 @@
 	mt->nameTuning[0] = "sliding window size";
 	mt->shortName = "slider";
 	mt->applicableTo[0] = SWITCH_UNI;
-	mt->applicableTo[1] = SWITCH_EXP;
-	mt->nApplicable = 2;
+	mt->applicableTo[1] = SWITCH_PINVUNI;
+	mt->applicableTo[2] = SWITCH_EXP;
+	mt->nApplicable = 3;
 	mt->moveFxn = &Move_SwitchRate;
-	mt->relProposalProb = 1.0;
+	mt->relProposalProb = 3.0; /* was 1.0 - Allen */
 	mt->numTuningParams = 1;
-	mt->tuningParam[0] = 1.0;  /* window size */
+	mt->tuningParam[0] = 0.0006;  /* window size */ /* was 1.0 - Allen */
 	mt->minimum[0] = 0.00001;
-	mt->maximum[0] = 1000.0;
+	mt->maximum[0] = 200.0; /* window size more sensible max */
 	mt->parsimonyBased = NO;
+	mt->doAdaptParam = YES; /* XXX - Allen */
+	mt->whichAdaptParam = 0;
+	/* leaving minAdaptCFactor at default */
 	mt->level = STANDARD_USER;
 
 	/* Move_SwitchRate_M */
@@ -39218,7 +41153,7 @@
 	mt->moveFxn = &Move_SwitchRate_M;
 	mt->relProposalProb = 0.0;
 	mt->numTuningParams = 1;
-	mt->tuningParam[0] = 2.0 * log (1.5);  /* lambda */
+	mt->tuningParam[0] = 2.0 * log (1.6);  /* lambda */
 	mt->minimum[0] = 0.00001;
 	mt->maximum[0] = 10000000.0;
 	mt->parsimonyBased = NO;
@@ -39930,7 +41865,7 @@
 	int			i, j, k, index;
 	MrBFlt		t, u, x, z, beta, bigPi_j[4], pij, bigPij,
 				*catRate, baseRate, theRate, *pis;
-	CLFlt		*tiP;
+	CLFlt2		*tiP;
 	ModelInfo	*m;
 #	if defined SSE
 	float		temp[16];
@@ -40055,7 +41990,7 @@
 	register int	i, j, k, n, s, index;
 	MrBFlt			t, *catRate, baseRate, *eigenValues, *cijk, 
 					EigValexp[64], sum, *ptr, theRate, correctionFactor;
-	CLFlt			*tiP;
+	CLFlt2			*tiP;
 	ModelInfo		*m;
 #if defined SSE
 	float			temp[16];
@@ -40199,8 +42134,8 @@
 	
 	register int	i, j, k, n, s, index;
 	int				sizeOfSingleCijk;
-	MrBFlt			t, *eigenValues, *cijk, EigValexp[64], sum, *ptr, correctionFactor;
-	CLFlt			*tiP;
+	MrBFlt			t, *eigenValues, *cijk, EigValexp[64], sum, *ptr, correctionFactor, baseRate;
+	CLFlt2			*tiP;
 	ModelInfo		*m;
 	
 	m = &modelSettings[division];
@@ -40235,10 +42170,13 @@
 	   cijk information for these models) */
 	sizeOfSingleCijk = m->nCijk / m->nCijkParts;
 
+	/* get base rate - Allen */
+	baseRate =  GetRate (division, chain);
+
 	/* fill in values */
 	for (k=index=0; k<m->nCijkParts; k++)
 		{
-		t =  p->length * correctionFactor;
+		t =  p->length * baseRate * correctionFactor;
 		for (s=0; s<n; s++)
 			EigValexp[s] =  exp(eigenValues[s] * t);
 
@@ -40294,7 +42232,7 @@
 	int			i, j, k, index;
 	MrBFlt		t, kap, u, w, x, y, z, beta, bigPi_j[4], pij, bigPij, *pis,
 				*catRate, baseRate, theRate;
-	CLFlt		*tiP;
+	CLFlt2		*tiP;
 	ModelInfo	*m;
 #if defined SSE
 	float		temp[16];
@@ -40422,7 +42360,8 @@
 	
 	int			i, j, k, index;
 	MrBFlt		*catRate, baseRate;
-	CLFlt		pNoChange, pChange, *tiP;
+	CLFlt		pNoChange, pChange;
+	CLFlt2          *tiP;
 	ModelInfo	*m;
 #if defined SSE
 	float		temp[16];
@@ -40517,7 +42456,7 @@
 	int			k, index;
 	MrBFlt		baseRate, eV, mu, theRate, v,
 				*bs, *catRate;
-	CLFlt		*tiP;
+	CLFlt2		*tiP;
 	ModelInfo	*m;
 	
 	/* find model settings for the division */
@@ -40574,7 +42513,8 @@
 	MrBFlt		v, eV1, eV2, eV3, eV4, eV5, *catRate,
 				baseRate, theRate, pi, f1, f2, f3, f4, f5, f6, f7, root, EigValexp[10],
 				*eigenValues, *cijk, sum, *bs, mu;
-	CLFlt		pNoChange, pChange, *tiP;
+	CLFlt		pNoChange, pChange;
+	CLFlt2          *tiP;
 	ModelInfo	*m;
 #	if defined (DEBUG_TIPROBS_STD)
 	int			index3;
